#include <ia32intrin.h>

extern "C" int dot_product(short *t, short *w, int n) {
  __m128i addsums;
  t-=8;
  w-=8;
  n=(n+7)&-8;
  while(n>0) {
    __m128i packsums,tpack,wpack;
    tpack=_mm_load_si128 ( (__m128i*)&(t[n]) );
    wpack=_mm_load_si128 ( (__m128i*)&(w[n]) );    
    packsums=_mm_madd_epi16 ( tpack, wpack );
    packsums=_mm_srai_epi32 ( packsums, 8 );
    addsums=_mm_add_epi32 ( addsums, packsums );
    n-=8;
  }
  addsums=_mm_add_epi32 ( addsums, _mm_srli_si128(addsums,8) );
  addsums=_mm_add_epi32 ( addsums, _mm_srli_si128(addsums,4) );
  return _mm_cvtsi128_si32 ( addsums );
}

#pragma const_seg(".text")
__declspec(aligned(16)) static const int train_one[4]={0x10001,0x10001,0x10001,0x10001};
#pragma const_seg()

extern "C" void train(short *t, short *w, int n, int err) {
  __m128i errsums,trainone;
  t-=8;
  w-=8;
  n=(n+7)&-8;
  errsums=_mm_cvtsi32_si128(err);
  errsums=_mm_shufflelo_epi16(errsums,0);
  errsums=_mm_unpacklo_epi64(errsums,errsums);
  trainone=_mm_load_si128 ( (__m128i*)&train_one );
  while(n>0) {
    __m128i packsums,tpack,wpack;
    tpack=_mm_load_si128 ( (__m128i*)&(t[n]) );
    wpack=_mm_load_si128 ( (__m128i*)&(w[n]) );
    tpack=_mm_adds_epi16(tpack,tpack);    
    tpack=_mm_mulhi_epi16(tpack,errsums);
    tpack=_mm_adds_epi16(tpack,trainone);
    tpack=_mm_srai_epi16(tpack,1);
    wpack=_mm_adds_epi16(wpack,tpack);

    _mm_store_si128( (__m128i*)&(w[n]) , wpack );
    n-=8;
  }
}

